package com.yuandian.dataflow.rpc;

import static io.grpc.MethodDescriptor.generateFullMethodName;

/**
 */
@javax.annotation.Generated(
    value = "by gRPC proto compiler (version 1.46.0)",
    comments = "Source: scheduler.proto")
@io.grpc.stub.annotations.GrpcGenerated
public final class DataFlowGrpc {

  private DataFlowGrpc() {}

  public static final String SERVICE_NAME = "com.yuandian.dataflow.rpc.DataFlow";

  // Static method descriptors that strictly reflect the proto.
  private static volatile io.grpc.MethodDescriptor<com.yuandian.dataflow.rpc.Scheduler.State,
      com.yuandian.dataflow.rpc.Scheduler.Response> getUpdateMethod;

  @io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "Update",
      requestType = com.yuandian.dataflow.rpc.Scheduler.State.class,
      responseType = com.yuandian.dataflow.rpc.Scheduler.Response.class,
      methodType = io.grpc.MethodDescriptor.MethodType.UNARY)
  public static io.grpc.MethodDescriptor<com.yuandian.dataflow.rpc.Scheduler.State,
      com.yuandian.dataflow.rpc.Scheduler.Response> getUpdateMethod() {
    io.grpc.MethodDescriptor<com.yuandian.dataflow.rpc.Scheduler.State, com.yuandian.dataflow.rpc.Scheduler.Response> getUpdateMethod;
    if ((getUpdateMethod = DataFlowGrpc.getUpdateMethod) == null) {
      synchronized (DataFlowGrpc.class) {
        if ((getUpdateMethod = DataFlowGrpc.getUpdateMethod) == null) {
          DataFlowGrpc.getUpdateMethod = getUpdateMethod =
              io.grpc.MethodDescriptor.<com.yuandian.dataflow.rpc.Scheduler.State, com.yuandian.dataflow.rpc.Scheduler.Response>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(SERVICE_NAME, "Update"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.yuandian.dataflow.rpc.Scheduler.State.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.yuandian.dataflow.rpc.Scheduler.Response.getDefaultInstance()))
              .setSchemaDescriptor(new DataFlowMethodDescriptorSupplier("Update"))
              .build();
        }
      }
    }
    return getUpdateMethod;
  }

  /**
   * Creates a new async stub that supports all call types for the service
   */
  public static DataFlowStub newStub(io.grpc.Channel channel) {
    io.grpc.stub.AbstractStub.StubFactory<DataFlowStub> factory =
      new io.grpc.stub.AbstractStub.StubFactory<DataFlowStub>() {
        @java.lang.Override
        public DataFlowStub newStub(io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
          return new DataFlowStub(channel, callOptions);
        }
      };
    return DataFlowStub.newStub(factory, channel);
  }

  /**
   * Creates a new blocking-style stub that supports unary and streaming output calls on the service
   */
  public static DataFlowBlockingStub newBlockingStub(
      io.grpc.Channel channel) {
    io.grpc.stub.AbstractStub.StubFactory<DataFlowBlockingStub> factory =
      new io.grpc.stub.AbstractStub.StubFactory<DataFlowBlockingStub>() {
        @java.lang.Override
        public DataFlowBlockingStub newStub(io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
          return new DataFlowBlockingStub(channel, callOptions);
        }
      };
    return DataFlowBlockingStub.newStub(factory, channel);
  }

  /**
   * Creates a new ListenableFuture-style stub that supports unary calls on the service
   */
  public static DataFlowFutureStub newFutureStub(
      io.grpc.Channel channel) {
    io.grpc.stub.AbstractStub.StubFactory<DataFlowFutureStub> factory =
      new io.grpc.stub.AbstractStub.StubFactory<DataFlowFutureStub>() {
        @java.lang.Override
        public DataFlowFutureStub newStub(io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
          return new DataFlowFutureStub(channel, callOptions);
        }
      };
    return DataFlowFutureStub.newStub(factory, channel);
  }

  /**
   */
  public static abstract class DataFlowImplBase implements io.grpc.BindableService {

    /**
     */
    public void update(com.yuandian.dataflow.rpc.Scheduler.State request,
        io.grpc.stub.StreamObserver<com.yuandian.dataflow.rpc.Scheduler.Response> responseObserver) {
      io.grpc.stub.ServerCalls.asyncUnimplementedUnaryCall(getUpdateMethod(), responseObserver);
    }

    @java.lang.Override public final io.grpc.ServerServiceDefinition bindService() {
      return io.grpc.ServerServiceDefinition.builder(getServiceDescriptor())
          .addMethod(
            getUpdateMethod(),
            io.grpc.stub.ServerCalls.asyncUnaryCall(
              new MethodHandlers<
                com.yuandian.dataflow.rpc.Scheduler.State,
                com.yuandian.dataflow.rpc.Scheduler.Response>(
                  this, METHODID_UPDATE)))
          .build();
    }
  }

  /**
   */
  public static final class DataFlowStub extends io.grpc.stub.AbstractAsyncStub<DataFlowStub> {
    private DataFlowStub(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      super(channel, callOptions);
    }

    @java.lang.Override
    protected DataFlowStub build(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      return new DataFlowStub(channel, callOptions);
    }

    /**
     */
    public void update(com.yuandian.dataflow.rpc.Scheduler.State request,
        io.grpc.stub.StreamObserver<com.yuandian.dataflow.rpc.Scheduler.Response> responseObserver) {
      io.grpc.stub.ClientCalls.asyncUnaryCall(
          getChannel().newCall(getUpdateMethod(), getCallOptions()), request, responseObserver);
    }
  }

  /**
   */
  public static final class DataFlowBlockingStub extends io.grpc.stub.AbstractBlockingStub<DataFlowBlockingStub> {
    private DataFlowBlockingStub(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      super(channel, callOptions);
    }

    @java.lang.Override
    protected DataFlowBlockingStub build(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      return new DataFlowBlockingStub(channel, callOptions);
    }

    /**
     */
    public com.yuandian.dataflow.rpc.Scheduler.Response update(com.yuandian.dataflow.rpc.Scheduler.State request) {
      return io.grpc.stub.ClientCalls.blockingUnaryCall(
          getChannel(), getUpdateMethod(), getCallOptions(), request);
    }
  }

  /**
   */
  public static final class DataFlowFutureStub extends io.grpc.stub.AbstractFutureStub<DataFlowFutureStub> {
    private DataFlowFutureStub(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      super(channel, callOptions);
    }

    @java.lang.Override
    protected DataFlowFutureStub build(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      return new DataFlowFutureStub(channel, callOptions);
    }

    /**
     */
    public com.google.common.util.concurrent.ListenableFuture<com.yuandian.dataflow.rpc.Scheduler.Response> update(
        com.yuandian.dataflow.rpc.Scheduler.State request) {
      return io.grpc.stub.ClientCalls.futureUnaryCall(
          getChannel().newCall(getUpdateMethod(), getCallOptions()), request);
    }
  }

  private static final int METHODID_UPDATE = 0;

  private static final class MethodHandlers<Req, Resp> implements
      io.grpc.stub.ServerCalls.UnaryMethod<Req, Resp>,
      io.grpc.stub.ServerCalls.ServerStreamingMethod<Req, Resp>,
      io.grpc.stub.ServerCalls.ClientStreamingMethod<Req, Resp>,
      io.grpc.stub.ServerCalls.BidiStreamingMethod<Req, Resp> {
    private final DataFlowImplBase serviceImpl;
    private final int methodId;

    MethodHandlers(DataFlowImplBase serviceImpl, int methodId) {
      this.serviceImpl = serviceImpl;
      this.methodId = methodId;
    }

    @java.lang.Override
    @java.lang.SuppressWarnings("unchecked")
    public void invoke(Req request, io.grpc.stub.StreamObserver<Resp> responseObserver) {
      switch (methodId) {
        case METHODID_UPDATE:
          serviceImpl.update((com.yuandian.dataflow.rpc.Scheduler.State) request,
              (io.grpc.stub.StreamObserver<com.yuandian.dataflow.rpc.Scheduler.Response>) responseObserver);
          break;
        default:
          throw new AssertionError();
      }
    }

    @java.lang.Override
    @java.lang.SuppressWarnings("unchecked")
    public io.grpc.stub.StreamObserver<Req> invoke(
        io.grpc.stub.StreamObserver<Resp> responseObserver) {
      switch (methodId) {
        default:
          throw new AssertionError();
      }
    }
  }

  private static abstract class DataFlowBaseDescriptorSupplier
      implements io.grpc.protobuf.ProtoFileDescriptorSupplier, io.grpc.protobuf.ProtoServiceDescriptorSupplier {
    DataFlowBaseDescriptorSupplier() {}

    @java.lang.Override
    public com.google.protobuf.Descriptors.FileDescriptor getFileDescriptor() {
      return com.yuandian.dataflow.rpc.Scheduler.getDescriptor();
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.ServiceDescriptor getServiceDescriptor() {
      return getFileDescriptor().findServiceByName("DataFlow");
    }
  }

  private static final class DataFlowFileDescriptorSupplier
      extends DataFlowBaseDescriptorSupplier {
    DataFlowFileDescriptorSupplier() {}
  }

  private static final class DataFlowMethodDescriptorSupplier
      extends DataFlowBaseDescriptorSupplier
      implements io.grpc.protobuf.ProtoMethodDescriptorSupplier {
    private final String methodName;

    DataFlowMethodDescriptorSupplier(String methodName) {
      this.methodName = methodName;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.MethodDescriptor getMethodDescriptor() {
      return getServiceDescriptor().findMethodByName(methodName);
    }
  }

  private static volatile io.grpc.ServiceDescriptor serviceDescriptor;

  public static io.grpc.ServiceDescriptor getServiceDescriptor() {
    io.grpc.ServiceDescriptor result = serviceDescriptor;
    if (result == null) {
      synchronized (DataFlowGrpc.class) {
        result = serviceDescriptor;
        if (result == null) {
          serviceDescriptor = result = io.grpc.ServiceDescriptor.newBuilder(SERVICE_NAME)
              .setSchemaDescriptor(new DataFlowFileDescriptorSupplier())
              .addMethod(getUpdateMethod())
              .build();
        }
      }
    }
    return result;
  }
}
